/**
 * Created with
 * @author: 林子/junhui.zhang@htwins.com.cn
 * @data: 17-8-30
 * @time: 上午9:17
 * @file:
 */


var fs = require('fs');
var path = require('path');
var stat = fs.stat;

var rootFile = './src';
var sourceFile = '../../pavilion-frontend/dep/htwins-angular-ui';

//清空文件夹
var deleteFolder = module.exports.deleteFolder = function (path) {
  console.log(fs.existsSync(path));
  var files = [];

  if (fs.existsSync(path)) {
    console.log(path);
    files = fs.readdirSync(path);
    files.forEach(function (file, index) {
      var curPath = path + "/" + file;
      if (fs.statSync(curPath).isDirectory()) { // recurse
        deleteFolder(curPath);
      } else { // delete file
        fs.unlinkSync(curPath);
      }
    });
    fs.rmdirSync(path);
  }
};

//创建文件夹
var newFolder = module.exports.newFolder = function (path) {
  fs.mkdir(path, function (err) {
    if (err) throw err;
  });
};


var copyFile = function (src, dst) {
  console.log('拉取文件：', src);
  stat(src, function (err, st) {
    if (err) {
      throw err;
    }
    // 判断是否为文件
    if (st.isFile()) {
      // 创建读取流
      readable = fs.createReadStream(src);
      // 创建写入流
      writable = fs.createWriteStream(dst);
      // 通过管道来传输流
      readable.pipe(writable);
    }
    // 如果是目录则递归调用自身
    else if (st.isDirectory()) {
      exists(_src, _dst, copy);
    }
  });
};

/*
 * 复制目录中的所有文件包括子目录
 * @param{ String } 需要复制的目录
 * @param{ String } 复制到指定的目录
 */
var copy = function (src, dst) {
  console.log('拉取目录：', src);
  // 读取目录中的所有文件/目录
  fs.readdir(src, function (err, paths) {
    if (err) {
      throw err;
    }
    paths.forEach(function (path) {
      var _src = src + '/' + path,
        _dst = dst + '/' + path,
        readable, writable;
      stat(_src, function (err, st) {
        if (err) {
          throw err;
        }
        // 判断是否为文件
        if (st.isFile()) {
          // 创建读取流
          readable = fs.createReadStream(_src);
          // 创建写入流
          writable = fs.createWriteStream(_dst);
          // 通过管道来传输流
          readable.pipe(writable);
        }
        // 如果是目录则递归调用自身
        else if (st.isDirectory()) {
          exists(_src, _dst, copy);
        }
      });
    });
  });

};
// 在复制目录前需要判断该目录是否存在，不存在需要先创建目录
var exists = function (src, dst, callback) {
  fs.exists(dst, function (exists) {
    // 已存在
    if (exists) {
      callback(src, dst);
    }
    // 不存在
    else {
      fs.mkdir(dst, function () {
        callback(src, dst);
      });
    }
  });
};

//删除文件夹
deleteFolder(rootFile);

//创建文件夹
newFolder(rootFile);

// 复制css
exists(path.join(__dirname, sourceFile), rootFile, copy);
