/**
 * Created with
 * @author: 林子/junhui.zhang@htwins.com.cn
 * @data: 17-8-30
 * @time: 下午2:20
 * @file:
 */

/**
 * ng-repeat 执行完了执行
 *
 * html:
 * <div class="swiper-slide" ng-repeat="item in lastedCompanyAds" on-finish-render-filters>
 * </div>
 *
 * js:
 * $scope.$on('ngRepeatFinished', function (data) {
 *  操作 。。。
 * });
 */

angular.module('htwins.ui.directive.onFinishRenderFilters', [])
  .directive('onFinishRenderFilters', function ($timeout) {
    return {
      restrict: 'A',
      link: function (scope, element, attr) {
        if (scope.$last === true) {
          $timeout(function () {
            scope.$emit('ngRepeatFinished');
          });
        }
      }
    };
  });