/**
 * Created with
 * @author: 林子/junhui.zhang@htwins.com.cn
 * @data: 17-8-30
 * @time: 上午10:33
 * @file:
 */
angular.module('htwins.ui.service.ajax', [])
  .service('htAjax', [function () {
    return {
      httpRequest: function (param) {

        var xmlhttprequest;
        if (window.XMLHttpRequest) {
          xmlhttprequest = new XMLHttpRequest();
          if (xmlhttprequest.overrideMimeType) {
            xmlhttprequest.overrideMimeType("text/xml");
          }
        } else if (window.ActiveXObject) {
          var activeName = ["MSXML2.XMLHTTP", "Microsoft.XMLHTTP"];
          for (var i = 0; i < activeName.length; i++) {
            try {
              xmlhttprequest = new ActiveXObject(activeName[i]);
              break;
            } catch (e) {

            }
          }
        }


        if (xmlhttprequest == undefined || xmlhttprequest == null) {
          alert("XMLHttpRequest对象创建失败！！");
        } else {
          this.xmlhttp = xmlhttprequest;
        }

        // 设置POST请求的请求头
        if (param.type == "post" || param.type == "POST") {
          xmlhttprequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        }

        if (param.async) {
          xmlhttprequest.responseType = "text";
          xmlhttprequest.onload = function (e) {
            if (xmlhttprequest.readyState === 4) {
              if (xmlhttprequest.status === 200) {
                param.success(xmlhttprequest.responseText);
              } else {
                param.error(xmlhttprequest.responseText);
              }
            }
          };
        }

        xmlhttprequest.open(param.type, param.url, param.async);
        xmlhttprequest.send(param.data);
        if (!param.async) {
          var responseResult = angular.fromJson(xmlhttprequest.responseText);  //angularJSON转换
          param.success(responseResult);
        }
      }
    }
  }]);
